import { ChevronRightIcon } from '@/assets/vectors/icons/ChevronRightIcon';
import { ChevronLeftIcon } from '@/assets/vectors/icons/ChevronLeftIcon';
import { ChevronUpIcon } from '@/assets/vectors/icons/ChevronUpIcon';
import { ChevronDownIcon } from '@/assets/vectors/icons/ChevronDownIcon';
import { PlusIcon } from '@/assets/vectors/icons/PlusIcon';
import { ArrowIcon } from '@/assets/vectors/icons/ArrowIcon';
import { DotsIcon } from '@/assets/vectors/icons/DotsIcon';
import { AdminIcon } from '@/assets/vectors/icons/AdminIcon';
import { ExportIcon } from '@/assets/vectors/icons/ExportIcon';
import { InfoIcon } from '@/assets/vectors/icons/InfoIcon';
import { LegendIcon } from '@/assets/vectors/icons/LegendIcon';
import { PageIcon } from '@/assets/vectors/icons/PageIcon';
import { PluginIcon } from '@/assets/vectors/icons/PluginIcon';

import type { IconTypes } from '@/types/iconTypes';

export interface IconProps {
  className?: string;
  name: IconTypes;
}

const icons = {
  'chevron-right': ChevronRightIcon,
  'chevron-left': ChevronLeftIcon,
  'chevron-up': ChevronUpIcon,
  'chevron-down': ChevronDownIcon,
  plus: PlusIcon,
  arrow: ArrowIcon,
  dots: DotsIcon,
  admin: AdminIcon,
  export: ExportIcon,
  info: InfoIcon,
  legend: LegendIcon,
  page: PageIcon,
  plugin: PluginIcon,
} as const;

export const Icon = ({ name, className = '' }: IconProps): JSX.Element => {
  if (typeof name === 'undefined') {
    throw new Error('Icon component must have a name of icon!');
  }
  const IconComponent = icons[name];

  return <IconComponent className={className} />;
};

Icon.displayName = 'Icon';
